package com.fsx.service;

import com.fsx.model.Card;
import com.fsx.model.User;

import java.io.*;
import java.util.HashMap;
import java.util.Random;
import java.util.Scanner;

/**
 * ATM业务
 */
@SuppressWarnings("all")
public class ATMService {
    Scanner input = new Scanner(System.in);
    HashMap<String, User> map = null;

    //反序列化读取文件
    {
        ObjectInputStream ois = null;
        //文件可能不存在
        try {
            //读取文件
            ois = new ObjectInputStream(new FileInputStream("E:\\IDEA\\IDEA_Project\\模拟ATM银行取款系统\\data.dat"));
            Object o = ois.readObject();
            //转换成map对象
            map = (HashMap) o;
        } catch (IOException | ClassNotFoundException e) {
            //第一次运行文件会不存在，创建文件data.dat
            File file = new File("E:\\IDEA\\IDEA_Project\\模拟ATM银行取款系统\\data.dat");
            file.getParentFile().mkdirs();
            try {
                file.createNewFile();
                map = new HashMap<String, User>();
            } catch (IOException ioException) {
                ioException.printStackTrace();
            }
        } finally {
            try {
                if (ois != null) {
                    //关闭对象流
                    ois.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    //开户
    public void createUser() {
        String cardId = cardID();
        System.out.println("请输入你的姓名：");
        String username = input.next();
        System.out.println("请输入你的身份证件号码：");
        String idCard = input.next();
        System.out.println("请输入你的手机号码：");
        String phone = input.next();
        System.out.println("请输入银行卡密码：");
        String idPsw = input.next();
        System.out.println("请再次输入银行卡密码：");
        String idPsw2 = input.next();
        if (!idPsw.equals(idPsw2)) {
            System.out.println("密码不一致，请重新开户！");
            return;
        }
        //创建对象
        Card card = new Card(cardId, idPsw);
        User user = new User(username, idCard, phone, card);
        //添加对象到map中
        map.put(cardId, user);
        System.out.println("开户成功!");
        System.out.println("你的卡号是：" + cardId);
    }

    //开户得到随机ID卡号
    public String cardID() {
        String cardId = "";
        Random r = new Random();
        for (int i = 0; i < 6; i++) {
            cardId += r.nextInt(10);
        }
        //如果随机生成的账号已存在，重新生成
        if (map.get(cardId) != null) {
            cardID();
        }
        return cardId;
    }

    //查询
    public void searchUserInfo() {
        System.out.println("请输入你的银行卡号：");
        String cardId = input.next();
        User user = map.get(cardId);
        //判断用户是否存在
        if (user == null) {
            System.out.println("用户不存在！");
            return;
        }
        //判断用户状态
        if (!user.getCard().isCardStatus()) {
            System.out.println("状态被锁定");
            return;
        }
        System.out.println("请输入你的密码：(3)");
        String psw = input.next();
        //判断用户密码是否正确
        if (!checkPWD(psw, user)) {
            System.out.println("账户异常！");
            return;
        }
        System.out.println("卡号：" + user.getCard().getCardId() + "\t\t余额：" + user.getCard().getCardmoney());
    }

    //取款
    public void getMoney() {
        System.out.println("请输入你的银行卡号：");
        String cardId = input.next();
        User user = map.get(cardId);
        //判断用户是否存在
        if (user == null) {
            System.out.println("用户不存在！");
            return;
        }
        //判断用户状态
        if (!user.getCard().isCardStatus()) {
            System.out.println("状态被锁定");
            return;
        }
        System.out.println("请输入取款金额：");
        double money = input.nextDouble();
        System.out.println("请输入你的密码：(3)");
        String psw = input.next();
        //判断用户密码是否正确
        if (!checkPWD(psw, user)) {
            System.out.println("密码错误！");
            return;
        }
        //得到该用户上次的金额
        double cardmoney = user.getCard().getCardmoney();
        //修改用户账号上的金额
        user.getCard().setCardmoney(cardmoney - money);
        System.out.println("卡号：" + user.getCard().getCardId() + "\t\t余额：" + user.getCard().getCardmoney());
        return;
    }

    //存款
    public void saveMoney() {
        System.out.println("请输入你的银行卡号：");
        String cardId = input.next();
        User user = map.get(cardId);
        //判断用户是否存在
        if (user == null) {
            System.out.println("用户不存在！");
            return;
        }
        //判断用户状态
        if (!user.getCard().isCardStatus()) {
            System.out.println("状态被锁定");
            return;
        }
        System.out.println("请输入存款金额：");
        double money = input.nextDouble();
        System.out.println("请输入你的密码：(3)");
        String psw = input.next();
        //判断用户密码是否正确
        if (!checkPWD(psw, user)) {
            System.out.println("密码错误！");
            return;
        }
        //得到该用户上次的金额
        double cardmoney = user.getCard().getCardmoney();
        //修改用户账号上的金额
        user.getCard().setCardmoney(cardmoney + money);
        System.out.println("卡号：" + user.getCard().getCardId() + "\t\t余额：" + user.getCard().getCardmoney());
        return;
    }

    //转账
    public void transferMoney() {
        System.out.println("请输入你的银行卡号：");
        String cardId = input.next();
        User user = map.get(cardId);
        //判断用户是否存在
        if (user == null) {
            System.out.println("用户不存在！");
            return;
        }
        //判断用户状态
        if (!user.getCard().isCardStatus()) {
            System.out.println("状态被锁定");
            return;
        }
        //判断收款人是否存在
        System.out.println("请输入收款人账号：");
        String cardID = input.next();
        User user2 = map.get(cardID);
        if (user2 == null) {
            System.out.println("对方用户不存在！");
            return;
        }
        System.out.println("请输入转账金额：");
        double money = input.nextDouble();
        System.out.println("请输入你的密码：(3)");
        String psw = input.next();
        //判断用户密码是否正确
        if (!checkPWD(psw, user)) {
            System.out.println("密码错误！");
            return;
        }
        //得到转账人账户金额
        double cardmoney1 = user.getCard().getCardmoney();
        //得到收款人账户金额
        double cardmoney2 = user2.getCard().getCardmoney();
        //修改转账人账户金额
        user.getCard().setCardmoney(cardmoney1 - money);
        //修改收款人账户金额
        user2.getCard().setCardmoney(cardmoney2 + money);
        System.out.println("转账成功！");
        System.out.println("卡号：" + user.getCard().getCardId() + "\t\t余额：" + user.getCard().getCardmoney());
        return;
    }

    //改密
    public void updatePWD() {
        System.out.println("请输入你的银行卡号：");
        String cardId = input.next();
        User user = map.get(cardId);
        //判断用户是否存在
        if (user == null) {
            System.out.println("用户不存在！");
            return;
        }
        //判断用户状态
        if (!user.getCard().isCardStatus()) {
            System.out.println("状态被锁定");
            return;
        }
        System.out.println("请输入旧密码：(3)");
        String psw = input.next();
        //判断用户密码是否正确
        if (!checkPWD(psw, user)) {
            System.out.println("密码错误！");
            return;
        }
        System.out.println("请输入新密码：");
        psw = input.next();
        //修改用户密码
        user.getCard().setCardPasswd(psw);
        System.out.println("密码：" + user.getCard().getCardPasswd());
        System.out.println("修改成功！");
        return;
    }

    //解锁
    public void lock() {
        System.out.println("请输入你的银行卡号：");
        String cardId = input.next();
        User user = map.get(cardId);
        //判断用户是否存在
        if (user == null) {
            System.out.println("用户不存在！");
            return;
        }
        //判断用户状态
        if (user.getCard().isCardStatus()) {
            System.out.println("此卡未被锁定");
            return;
        }
        System.out.println("请输入密码：(3)");
        String psw = input.next();
        //判断用户密码是否正确
        if (!checkPWD(psw, user)) {
            System.out.println("密码错误！");
            return;
        }
        //修改用户状态
        user.getCard().setCardStatus(true);
        System.out.println("解锁成功！");
        return;
    }

    //锁定
    public void unLock() {
        System.out.println("请输入你的银行卡号：");
        String cardId = input.next();
        User user = map.get(cardId);
        //判断用户是否存在
        if (user == null) {
            System.out.println("用户不存在！");
            return;
        }
        //判断用户状态
        if (!user.getCard().isCardStatus()) {
            System.out.println("此卡已被锁定");
            return;
        }
        System.out.println("请输入密码：(3)");
        String psw = input.next();
        //判断用户密码是否正确
        if (!checkPWD(psw, user)) {
            System.out.println("密码错误！");
            return;
        }
        //修改用户状态
        user.getCard().setCardStatus(false);
        System.out.println("锁定成功！");
        return;
    }

    //退出
    public void exit() throws IOException {
       /* //删除之前读取的文件
        File file = new File("E:\\IDEA\\IDEA_Project\\模拟ATM银行取款系统\\data.dat");
        file.delete();*/
        //创建读入对象流
        ObjectOutputStream osw = new ObjectOutputStream(new FileOutputStream("E:\\IDEA\\IDEA_Project\\模拟ATM银行取款系统\\data.dat"));
        //将map对象写入文件中
        osw.writeObject(map);
        //关闭对象流
        osw.close();
    }

    //验证密码
    public boolean checkPWD(String psw, User user) {
        int index = 2;//记录次数
        while (true) {
            //验证密码是否正确
            if (!user.getCard().getCardPasswd().equals(psw) && index != 0) {
                System.out.println("密码错误，请重新输入密码：" + "(" + (index--) + ")");
                psw = input.next();
                continue;
            } else if (!user.getCard().getCardPasswd().equals(psw) && index == 0) {
                user.getCard().setCardStatus(false);
                System.out.println("此卡已被锁定！");
                return false;
            }
            return true;
        }
    }
}
