package com.fsx.view;

import com.fsx.service.ATMService;
import com.fsx.service.AdminService;

import java.io.IOException;
import java.util.Scanner;

/**
 * 视图层，调用业务层
 */
public class SysView {
    //业务对象
    AdminService admin = new AdminService();
    ATMService atm = new ATMService();
    //创建键盘录入对象
    Scanner input = new Scanner(System.in);

    public void start() {
        //1、管理员开机
        admin.printAdminView();

        //2、身份验证
        boolean result = admin.adminOperation();
        if (!result) {
            return;
        }

        while (true) {
            //3、跳转到系统功能界面
            admin.printSysFuncView();
            System.out.println("选择您想要执行的操作：");
            char c = input.next().charAt(0);
            switch (c) {
                case '1'://开户
                    atm.createUser();
                    break;
                case '2'://查询
                    atm.searchUserInfo();
                    break;
                case '3'://取钱
                    atm.getMoney();
                    break;
                case '4'://存钱
                    atm.saveMoney();
                    break;
                case '5'://转账
                    atm.transferMoney();
                    break;
                case '6'://改密
                    atm.updatePWD();
                    break;
                case '7'://解锁
                    atm.lock();
                    break;
                case '8'://锁定
                    atm.unLock();
                    break;
                case 't'://退出
                    try {
                        atm.exit();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    System.out.println("感谢您的使用！");
                    return;
            }
            try {
                //睡眠2秒
                Thread.sleep(2000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
